import { Ref, ref } from "vue";
import { BJ_Casino_Bot } from "./BJ_Casino_Bot";
import { SlotBase } from "./Common/Game/Base/Slot";
import { Tools } from "./Tools";

export class BJ_Casino_Bot_Slot {
    //#region public

    public BetIndex: Ref<string> = ref("");

    public SpinDelay: Ref<number> = ref(1);

    public IsRatioStop: Ref<boolean> = ref(false);

    public RatioStop: Ref<number> = ref(100);

    public IsCountStop: Ref<boolean> = ref(false);

    public CountStop: Ref<number> = ref(100);

    public Slot: SlotBase = null;

    public GameInData: any = null;

    public BetGroup: number[] = [];

    public NowBetIndex: number = null;

    public IsSpin: Ref<boolean> = ref(false);

    public IsRun: boolean = false;

    //#endregion

    //#region private

    private _bj_Casino_Bot: BJ_Casino_Bot;

    //#endregion

    //#region get set

    public get NowBet(): number { return +this.BetGroup[this.NowBetIndex]; }

    //#endregion

    //#region Lifecycle

    /**
     *
     */
    constructor(bj_Casino_Bot: BJ_Casino_Bot) {
        this._bj_Casino_Bot = bj_Casino_Bot;
        this.onLoad();
    }

    public async onLoad(): Promise<void> {
        //
    }

    public async GameIn(gameInData: any): Promise<void> {
        this.GameInData = gameInData;
        let Data: any = gameInData.Data;
        this.BetGroup = Data.br;
        this.NowBetIndex = Data.db;
        this.BetIndex.value = this.BetGroup[Data.db].toString();
    }

    //#endregion

    //#region Custom

    public async Spin(): Promise<void> {
        if (this._bj_Casino_Bot.UserData.Money < this.NowBet) {
            this.NoMoney();
            return;
        }
        if (this.IsCountStop.value) {
            if (this.CountStop.value <= 0) {
                this.OnclickStop();
                return;
            }
            this.CountStop.value -= 1;
        }
        this.IsRun = true;
        await this.Slot.Spin();
        await Tools.Sleep(this.SpinDelay.value * 1000);
        if (this.IsSpin.value && this._bj_Casino_Bot.LobbyScript.IsSlotIn.value) {
            this.Spin();
        } else {
            this.IsRun = false;
        }
    }

    public SelectBet(data: any): void {
        this.NowBetIndex = data;
        this.BetIndex.value = this.BetGroup[data].toString();
        this._bj_Casino_Bot.AddLog(`改變Bet: ${this.NowBet}`);
    }

    public NoMoney(): void {
        this.IsSpin.value = false;
        this.IsRun = false;
        this._bj_Casino_Bot.AddLog(`金額不足: ${this._bj_Casino_Bot.UserData.Money}`);
    }

    //#endregion

    //#region Onclick

    public async OnclickSpin(): Promise<void> {
        if (this.IsRun) {
            return;
        }
        let id: string = this._bj_Casino_Bot.LobbyScript.InputSlot.value;
        let slot: any;
        const slotGroup: typeof import("./Common/Game/Base/Slot") = await import(/* @vite-ignore */`./Common/Game/Base/Slot`);
        try {
            // slot = await import(/* @vite-ignore */`./Common/Game/Slot${id}`);
            slot = slotGroup[`Slot${id}`];
        } catch (error) {
            // this._bj_Casino_Bot.AddLog(`Slot${id} Spin error: ${error}`);
        }
        if (!slot) {
            slot = slotGroup.SlotBase;
        }
        // const slot_default: typeof SlotBase = slot.default;
        // this.Slot = new slot_default(this._bj_Casino_Bot, this);
        this.Slot = new slot(this._bj_Casino_Bot, this);
        this.IsSpin.value = true;
        this.Spin();
    }

    public async OnclickStop(): Promise<void> {
        this.IsSpin.value = false;
    }

    //#endregion
}
