import { NetRequest } from "../../Engine/CatanEngine/NetManagerV2/NetRequest";


interface SeatListResquest {
    hall: number;
    slot: number;
}
/** 機台所有座位 */
export class SeatListRequest extends NetRequest<SeatListResquest, JSON> {
    get Method(): string {
        return "seat.list";
    }
    constructor(HallType: number, SlotID: number) {
        super();
        this.Data = {
            hall: HallType,
            slot: SlotID
        };
    }
}

interface SeatInfoResquest {
    hall: number;
    slot: number;
    id: number;
}

/** 獨立座位資料 */
export class SeatInfoRequest extends NetRequest<SeatInfoResquest, JSON> {
    get Method(): string {
        return "seat.info";
    }
    constructor(HallType: number, SlotID: number, ID: number) {
        super();
        this.Data = {
            hall: HallType,
            slot: SlotID,
            id: ID
        };
    }
}

/** 機台佔用 */
export class SeatOccupy extends NetRequest<null, null> {
    get Method(): string {
        return "seat.occupy";
    }
    constructor() {
        super();
    }
}