﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * COLLECT_001猛瑪#collect_001.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Collect001Table extends TableBase<WithoutRow> {
	private _collect: CollectTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #collect */
	public get Collect(): CollectTable { return this._collect = this._collect || TableManager.InitTable("#collect_001#collect", CollectTable, CollectTableRow); }

	private _fixed: FixedTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#collect_001#fixed", FixedTable, FixedTableRow); }

	private _token: TokenTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #token */
	public get Token(): TokenTable { return this._token = this._token || TableManager.InitTable("#collect_001#token", TokenTable, TokenTableRow); }

	private _symbol: SymbolTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#collect_001#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#collect_001#pay", PayTable, PayTableRow); }

	private _wheelForm: WheelFormTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#collect_001#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  COLLECT_001猛瑪#collect_001.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#collect_001#wheel_client", WheelClientTable, WheelClientTableRow); }
}

/**
 * #collect
 */
export class CollectTable extends TableBase<CollectTableRow> {}

export class CollectTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 此區單格所需token */
	Tokens: number;
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** 共用(名稱) */
	BName: string;
	/** client專用(值) */
	CValue: number;
	/** client專用(名稱) */
	CName: string;
}

/**
 * #token
 */
export class TokenTable extends TableBase<TokenTableRow> {}

export class TokenTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** token種類 */
	TokenType: number;
	/** token數量 */
	Token: any;
	/** 可掛token的圖標 */
	PermitSymbols: any;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}
