﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_五星彩#five.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class FiveTable extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  系統_五星彩#five.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#five#fixed", FixedTable, FixedTableRow); }

	private _award: AwardTable;
	/**  系統_五星彩#five.xlsx > #award */
	public get Award(): AwardTable { return this._award = this._award || TableManager.InitTable("#five#award", AwardTable, AwardTableRow); }

	private _string: StringTable;
	/**  系統_五星彩#five.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#five#string", StringTable, StringTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 值 */
	BValue: number;
	/** 值 */
	CValue: number;
}

/**
 * #award
 */
export class AwardTable extends TableBase<AwardTableRow> {}

export class AwardTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 值 */
	Award1: number;
	/** 值 */
	Award2: number;
	/** 值 */
	Award3: number;
	/** 值 */
	Award4: number;
	/** 值 */
	Award5: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 介面字串 */
	MsgZnTw: string;
}
