﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_表單讀取#formread.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class FormreadTable extends TableBase<FormreadTableRow> {
	private _setting: SettingTable;
	/**  系統_表單讀取#formread.xlsx > #setting */
	public get Setting(): SettingTable { return this._setting = this._setting || TableManager.InitTable("#formread#setting", SettingTable, SettingTableRow); }

	private _txt: TxtTable;
	/**  系統_表單讀取#formread.xlsx > #txt */
	public get Txt(): TxtTable { return this._txt = this._txt || TableManager.InitTable("#formread#txt", TxtTable, TxtTableRow); }
}

export class FormreadTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 表單名稱 */
	Form: string;
}

/**
 * #setting
 */
export class SettingTable extends TableBase<SettingTableRow> {}

export class SettingTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 後台網域 */
	Form: string;
	Router: string;
}

/**
 * #txt
 */
export class TxtTable extends TableBase<TxtTableRow> {}

export class TxtTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 表單名稱 */
	Form: string;
	/** 版號 */
	Version: number;
}
