﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_贈禮#gift.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class GiftTable extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  系統_贈禮#gift.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#gift#fixed", FixedTable, FixedTableRow); }

	private _quantity: QuantityTable;
	/**  系統_贈禮#gift.xlsx > #quantity */
	public get Quantity(): QuantityTable { return this._quantity = this._quantity || TableManager.InitTable("#gift#quantity", QuantityTable, QuantityTableRow); }

	private _string: StringTable;
	/**  系統_贈禮#gift.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#gift#string", StringTable, StringTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 參數 */
	Value: number;
}

/**
 * #quantity
 */
export class QuantityTable extends TableBase<QuantityTableRow> {}

export class QuantityTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 活躍度 */
	Activity: number;
	/** 單日送禮次數限制 */
	Limit: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
	/** 越南文讯息 */
	MsgVi: string;
	/** 泰文讯息 */
	MsgTh: string;
}
