﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_跑馬燈#network.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class NetworkTable extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  系統_跑馬燈#network.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#network#fixed", FixedTable, FixedTableRow); }

	private _string: StringTable;
	/**  系統_跑馬燈#network.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#network#string", StringTable, StringTableRow); }

	private _condition: ConditionTable;
	/**  系統_跑馬燈#network.xlsx > #condition */
	public get Condition(): ConditionTable { return this._condition = this._condition || TableManager.InitTable("#network#condition", ConditionTable, ConditionTableRow); }

	private _priority: PriorityTable;
	/**  系統_跑馬燈#network.xlsx > #priority */
	public get Priority(): PriorityTable { return this._priority = this._priority || TableManager.InitTable("#network#priority", PriorityTable, PriorityTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 值 */
	CValue: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
	/** 越南文讯息 */
	MsgVi: string;
	/** 泰文讯息 */
	MsgTh: string;
}

/**
 * #condition
 */
export class ConditionTable extends TableBase<ConditionTableRow> {}

export class ConditionTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #priority
 */
export class PriorityTable extends TableBase<PriorityTableRow> {}

export class PriorityTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 後端廣播ID */
	ConditionId: number;
	/** 繁體中文訊息 */
	MsgZnTw: string;
}
