﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 遊藝館_九龍骰寶#nine_sicbo.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class NineSicboTable extends TableBase<WithoutRow> {
	private _bet: BetTable;
	/**  遊藝館_九龍骰寶#nine_sicbo.xlsx > #bet */
	public get Bet(): BetTable { return this._bet = this._bet || TableManager.InitTable("#nine_sicbo#bet", BetTable, BetTableRow); }

	private _fixed: FixedTable;
	/**  遊藝館_九龍骰寶#nine_sicbo.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#nine_sicbo#fixed", FixedTable, FixedTableRow); }

	private _paytable: PaytableTable;
	/**  遊藝館_九龍骰寶#nine_sicbo.xlsx > #paytable */
	public get Paytable(): PaytableTable { return this._paytable = this._paytable || TableManager.InitTable("#nine_sicbo#paytable", PaytableTable, PaytableTableRow); }

	private _string: StringTable;
	/**  遊藝館_九龍骰寶#nine_sicbo.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#nine_sicbo#string", StringTable, StringTableRow); }

	private _sound: SoundTable;
	/**  遊藝館_九龍骰寶#nine_sicbo.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#nine_sicbo#sound", SoundTable, SoundTableRow); }
}

/**
 * #bet
 */
export class BetTable extends TableBase<BetTableRow> {}

export class BetTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 顯示 */
	Show: any;
	/** 大小 */
	Type1: any;
	/** 骰子1~6 */
	Type2: any;
	/** 全圍骰 */
	Type3: any;
	/** 圍骰1~6 */
	Type4: any;
	/** 點數4 */
	Type5: any;
	/** 點數5 */
	Type6: any;
	/** 點數6 */
	Type7: any;
	/** 點數7 */
	Type8: any;
	/** 點數8 */
	Type9: any;
	/** 點數9 */
	Type10: any;
	/** 點數10 */
	Type11: any;
	/** 點數11 */
	Type12: any;
	/** 點數12 */
	Type13: any;
	/** 點數13 */
	Type14: any;
	/** 點數14 */
	Type15: any;
	/** 點數15 */
	Type16: any;
	/** 點數16 */
	Type17: any;
	/** 點數17 */
	Type18: any;
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 值 */
	Value: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #paytable
 */
export class PaytableTable extends TableBase<PaytableTableRow> {}

export class PaytableTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	PayNormal: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文訊息 */
	MsgZnCh: string;
	/** 越南文讯息 */
	MsgVi: string;
	/** 泰文讯息 */
	MsgTh: string;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置 */
	PathZnTw: string;
	/** 英文音檔位置(預設音檔位置) */
	PathEn: string;
}
