﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 系統_營運活動#operation.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class OperationTable extends TableBase<WithoutRow> {
	private _time: TimeTable;
	/**  系統_營運活動#operation.xlsx > #time */
	public get Time(): TimeTable { return this._time = this._time || TableManager.InitTable("#operation#time", TimeTable, TimeTableRow); }

	private _fixed: FixedTable;
	/**  系統_營運活動#operation.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#operation#fixed", FixedTable, FixedTableRow); }

	private _string: StringTable;
	/**  系統_營運活動#operation.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#operation#string", StringTable, StringTableRow); }
}

/**
 * #time
 */
export class TimeTable extends TableBase<TimeTableRow> {}

export class TimeTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 開始時間 */
	Timestart: string;
	/** 結束時間 */
	Timeend: string;
	/** 刷新時間 */
	Restard: string;
	/** 結算時間 */
	Settlement: string;
	/** 活動編號 */
	Activity: number;
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 繁體中文訊息 */
	MsgZnTw: string;
}
