﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_002火焰巨輪#slot_002.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot002Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_002#fixed", FixedTable, FixedTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_002#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_002#pay", PayTable, PayTableRow); }

	private _line: LineTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #line */
	public get Line(): LineTable { return this._line = this._line || TableManager.InitTable("#slot_002#line", LineTable, LineTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_002#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheel: WheelTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #wheel */
	public get Wheel(): WheelTable { return this._wheel = this._wheel || TableManager.InitTable("#slot_002#wheel", WheelTable, WheelTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_002#wheel_client", WheelClientTable, WheelClientTableRow); }

	private _bonusWheel: BonusWheelTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #bonus_wheel */
	public get BonusWheel(): BonusWheelTable { return this._bonusWheel = this._bonusWheel || TableManager.InitTable("#slot_002#bonus_wheel", BonusWheelTable, BonusWheelTableRow); }

	private _symbolWheel: SymbolWheelTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #symbol_wheel */
	public get SymbolWheel(): SymbolWheelTable { return this._symbolWheel = this._symbolWheel || TableManager.InitTable("#slot_002#symbol_wheel", SymbolWheelTable, SymbolWheelTableRow); }

	private _sound: SoundTable;
	/**  SLOT_002火焰巨輪#slot_002.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_002#sound", SoundTable, SoundTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #line
 */
export class LineTable extends TableBase<LineTableRow> {}

export class LineTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 線編號 */
	LineId: number;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel
 */
export class WheelTable extends TableBase<WheelTableRow> {}

export class WheelTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}

/**
 * #bonus_wheel
 */
export class BonusWheelTable extends TableBase<BonusWheelTableRow> {}

export class BonusWheelTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖片 */
	PicIdx: number;
}

/**
 * #symbol_wheel
 */
export class SymbolWheelTable extends TableBase<SymbolWheelTableRow> {}

export class SymbolWheelTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIdx: number;
	/** 底圖索引 */
	BgIdx: number;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}
