﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_020特務奇兵#slot_020.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot020Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_020#fixed", FixedTable, FixedTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_020#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_020#pay", PayTable, PayTableRow); }

	private _sound: SoundTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_020#sound", SoundTable, SoundTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_020#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_020#wheel_client", WheelClientTable, WheelClientTableRow); }

	private _freeMoney: FreeMoneyTable;
	/**  SLOT_020特務奇兵#slot_020.xlsx > #free_money */
	public get FreeMoney(): FreeMoneyTable { return this._freeMoney = this._freeMoney || TableManager.InitTable("#slot_020#free_money", FreeMoneyTable, FreeMoneyTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}

/**
 * #free_money
 */
export class FreeMoneyTable extends TableBase<FreeMoneyTableRow> {}

export class FreeMoneyTableRow implements ITableRow {
	/** 館別 */
	Id: number;
	/** 嘍囉上限 */
	Limit9: number;
	/** 嘍囉獎金 */
	Money9: any;
	/** 打手上限 */
	Limit8: number;
	/** 打手獎金 */
	Money8: any;
	/** 老大上限 */
	Limit7: number;
	/** 老大獎金 */
	Money7: any;
	/** 炸彈上限 */
	Limit6: number;
	/** 炸彈獎金 */
	Money6: any;
}
