﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_025鑽石之都#slot_025.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot025Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_025#fixed", FixedTable, FixedTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_025#symbol", SymbolTable, SymbolTableRow); }

	private _basepay: BasepayTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #basepay */
	public get Basepay(): BasepayTable { return this._basepay = this._basepay || TableManager.InitTable("#slot_025#basepay", BasepayTable, BasepayTableRow); }

	private _freepay: FreepayTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #freepay */
	public get Freepay(): FreepayTable { return this._freepay = this._freepay || TableManager.InitTable("#slot_025#freepay", FreepayTable, FreepayTableRow); }

	private _line: LineTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #line */
	public get Line(): LineTable { return this._line = this._line || TableManager.InitTable("#slot_025#line", LineTable, LineTableRow); }

	private _sound: SoundTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_025#sound", SoundTable, SoundTableRow); }

	private _ssMain: SsMainTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #ss_main */
	public get SsMain(): SsMainTable { return this._ssMain = this._ssMain || TableManager.InitTable("#slot_025#ss_main", SsMainTable, SsMainTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_025#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_025鑽石之都#slot_025.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_025#wheel_client", WheelClientTable, WheelClientTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #basepay
 */
export class BasepayTable extends TableBase<BasepayTableRow> {}

export class BasepayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #freepay
 */
export class FreepayTable extends TableBase<FreepayTableRow> {}

export class FreepayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #line
 */
export class LineTable extends TableBase<LineTableRow> {}

export class LineTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 線編號 */
	LineId: number;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}

/**
 * #ss_main
 */
export class SsMainTable extends TableBase<SsMainTableRow> {}

export class SsMainTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 權重 */
	Weight: any;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}
