﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_034招財金貓#slot_034.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot034Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_034#fixed", FixedTable, FixedTableRow); }

	private _multiplier: MultiplierTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #multiplier */
	public get Multiplier(): MultiplierTable { return this._multiplier = this._multiplier || TableManager.InitTable("#slot_034#multiplier", MultiplierTable, MultiplierTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_034#symbol", SymbolTable, SymbolTableRow); }

	private _basepay: BasepayTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #basepay */
	public get Basepay(): BasepayTable { return this._basepay = this._basepay || TableManager.InitTable("#slot_034#basepay", BasepayTable, BasepayTableRow); }

	private _freepay: FreepayTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #freepay */
	public get Freepay(): FreepayTable { return this._freepay = this._freepay || TableManager.InitTable("#slot_034#freepay", FreepayTable, FreepayTableRow); }

	private _line: LineTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #line */
	public get Line(): LineTable { return this._line = this._line || TableManager.InitTable("#slot_034#line", LineTable, LineTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_034#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_034#wheel_client", WheelClientTable, WheelClientTableRow); }

	private _sound: SoundTable;
	/**  SLOT_034招財金貓#slot_034.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_034#sound", SoundTable, SoundTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #multiplier
 */
export class MultiplierTable extends TableBase<MultiplierTableRow> {}

export class MultiplierTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 組合列數 */
	Rows: number;
	/** 組合行數 */
	Cols: number;
	/** 是否隨機 */
	Rand: number;
	/** 倍數(JP從-1,-2,-3,-4,-5表示-1為BigPot,-5為JP) */
	Multi: any;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
	/** 連續圖 */
	ContinuousPic: any;
	/** 連續圖 */
	PicNext: number;
	/** 連續圖 */
	PicPrev: number;
}

/**
 * #basepay
 */
export class BasepayTable extends TableBase<BasepayTableRow> {}

export class BasepayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #freepay
 */
export class FreepayTable extends TableBase<FreepayTableRow> {}

export class FreepayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #line
 */
export class LineTable extends TableBase<LineTableRow> {}

export class LineTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 線編號 */
	LineId: number;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}
