﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_051皇帝88#slot_051.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot051Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_051#fixed", FixedTable, FixedTableRow); }

	private _mainInfo: MainInfoTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #main_info */
	public get MainInfo(): MainInfoTable { return this._mainInfo = this._mainInfo || TableManager.InitTable("#slot_051#main_info", MainInfoTable, MainInfoTableRow); }

	private _freeInfo: FreeInfoTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #free_info */
	public get FreeInfo(): FreeInfoTable { return this._freeInfo = this._freeInfo || TableManager.InitTable("#slot_051#free_info", FreeInfoTable, FreeInfoTableRow); }

	private _diceInfo: DiceInfoTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #dice_info */
	public get DiceInfo(): DiceInfoTable { return this._diceInfo = this._diceInfo || TableManager.InitTable("#slot_051#dice_info", DiceInfoTable, DiceInfoTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_051#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_051#pay", PayTable, PayTableRow); }

	private _line: LineTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #line */
	public get Line(): LineTable { return this._line = this._line || TableManager.InitTable("#slot_051#line", LineTable, LineTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_051#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_051#wheel_client", WheelClientTable, WheelClientTableRow); }

	private _sound: SoundTable;
	/**  SLOT_051皇帝88#slot_051.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_051#sound", SoundTable, SoundTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #main_info
 */
export class MainInfoTable extends TableBase<MainInfoTableRow> {}

export class MainInfoTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 過wild倍數 */
	WildMulti: any;
}

/**
 * #free_info
 */
export class FreeInfoTable extends TableBase<FreeInfoTableRow> {}

export class FreeInfoTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 轉數 */
	Spins: number;
}

/**
 * #dice_info
 */
export class DiceInfoTable extends TableBase<DiceInfoTableRow> {}

export class DiceInfoTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 骰子數 */
	Dice: number;
	/** 賠率 */
	Pay: number;
	/** 升級倍率 */
	Up: any;
	/** 升級權重 */
	UpWeights: any;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
	/** 重複位移 */
	SameShift: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
}

/**
 * #line
 */
export class LineTable extends TableBase<LineTableRow> {}

export class LineTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 線編號 */
	LineId: number;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}
