﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * SLOT_055幸運美鈔#slot_055.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Slot055Table extends TableBase<WithoutRow> {
	private _fixed: FixedTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#slot_055#fixed", FixedTable, FixedTableRow); }

	private _symbol: SymbolTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #symbol */
	public get Symbol(): SymbolTable { return this._symbol = this._symbol || TableManager.InitTable("#slot_055#symbol", SymbolTable, SymbolTableRow); }

	private _pay: PayTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#slot_055#pay", PayTable, PayTableRow); }

	private _roulette: RouletteTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #roulette */
	public get Roulette(): RouletteTable { return this._roulette = this._roulette || TableManager.InitTable("#slot_055#roulette", RouletteTable, RouletteTableRow); }

	private _string: StringTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#slot_055#string", StringTable, StringTableRow); }

	private _sound: SoundTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#slot_055#sound", SoundTable, SoundTableRow); }

	private _wheelForm: WheelFormTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #wheel_form */
	public get WheelForm(): WheelFormTable { return this._wheelForm = this._wheelForm || TableManager.InitTable("#slot_055#wheel_form", WheelFormTable, WheelFormTableRow); }

	private _wheelClient: WheelClientTable;
	/**  SLOT_055幸運美鈔#slot_055.xlsx > #wheel_client */
	public get WheelClient(): WheelClientTable { return this._wheelClient = this._wheelClient || TableManager.InitTable("#slot_055#wheel_client", WheelClientTable, WheelClientTableRow); }
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #symbol
 */
export class SymbolTable extends TableBase<SymbolTableRow> {}

export class SymbolTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 圖檔索引 */
	PicIndex: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 賠率 */
	X1: number;
	/** 賠率 */
	X2: number;
	/** 賠率 */
	X3: number;
	/** 賠率 */
	X4: number;
	/** 賠率 */
	X5: number;
	/** 賠率 */
	X6: number;
	/** 賠率 */
	X7: number;
	/** 賠率 */
	X8: number;
	/** 賠率 */
	X9: number;
	/** 賠率 */
	X10: number;
	/** 賠率 */
	X11: number;
	/** 賠率 */
	X12: number;
	/** 賠率 */
	X13: number;
	/** 賠率 */
	X14: number;
	/** 賠率 */
	X15: number;
}

/**
 * #roulette
 */
export class RouletteTable extends TableBase<RouletteTableRow> {}

export class RouletteTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 種類 */
	Type: number;
	/** 數值 */
	TypeValue: number;
	/** 組合數 */
	ComboNumber: number;
	/** 組合 */
	Combo: any;
	/** 組合機率 */
	ComboWeights: any;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 繁體中文訊息(舊的不用填) */
	MsgCh: string;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文讯息 */
	MsgZnCh: string;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置(預設音檔位置) */
	PathZnTw: string;
}

/**
 * #wheel_form
 */
export class WheelFormTable extends TableBase<WheelFormTableRow> {}

export class WheelFormTableRow implements ITableRow {
	/** 編號 */
	Id: number;
}

/**
 * #wheel_client
 */
export class WheelClientTable extends TableBase<WheelClientTableRow> {}

export class WheelClientTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 輪軸列表 */
	SymbolList: any;
}
