﻿import { ITableRow, WithoutRow } from "../../Engine/CatanEngine/TableV3/Core/ITableRow";
import { TableBase } from "../../Engine/CatanEngine/TableV3/Core/TableBase";
import { TableManager } from "../../Engine/CatanEngine/TableV3/TableManager";

/**
 * 遊藝館_色碟#table3031.xlsx
 * ##程式碼由工具產生, 在此做的修改都將被覆蓋##
 */
export class Table3031Table extends TableBase<WithoutRow> {
	private _bet: BetTable;
	/**  遊藝館_色碟#table3031.xlsx > #bet */
	public get Bet(): BetTable { return this._bet = this._bet || TableManager.InitTable("#table3031#bet", BetTable, BetTableRow); }

	private _fixed: FixedTable;
	/**  遊藝館_色碟#table3031.xlsx > #fixed */
	public get Fixed(): FixedTable { return this._fixed = this._fixed || TableManager.InitTable("#table3031#fixed", FixedTable, FixedTableRow); }

	private _pay: PayTable;
	/**  遊藝館_色碟#table3031.xlsx > #pay */
	public get Pay(): PayTable { return this._pay = this._pay || TableManager.InitTable("#table3031#pay", PayTable, PayTableRow); }

	private _paytable: PaytableTable;
	/**  遊藝館_色碟#table3031.xlsx > #paytable */
	public get Paytable(): PaytableTable { return this._paytable = this._paytable || TableManager.InitTable("#table3031#paytable", PaytableTable, PaytableTableRow); }

	private _string: StringTable;
	/**  遊藝館_色碟#table3031.xlsx > #string */
	public get String(): StringTable { return this._string = this._string || TableManager.InitTable("#table3031#string", StringTable, StringTableRow); }

	private _sound: SoundTable;
	/**  遊藝館_色碟#table3031.xlsx > #sound */
	public get Sound(): SoundTable { return this._sound = this._sound || TableManager.InitTable("#table3031#sound", SoundTable, SoundTableRow); }
}

/**
 * #bet
 */
export class BetTable extends TableBase<BetTableRow> {}

export class BetTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 顯示 */
	Show: any;
	/** 大小 */
	Type1: any;
	/** 單雙 */
	Type2: any;
	/** 紅40 */
	Type3: any;
	/** 紅31 */
	Type4: any;
}

/**
 * #fixed
 */
export class FixedTable extends TableBase<FixedTableRow> {}

export class FixedTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 共用(值) */
	BValue: number;
	/** client專用(值) */
	CValue: number;
}

/**
 * #pay
 */
export class PayTable extends TableBase<PayTableRow> {}

export class PayTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 大 */
	Big: number;
	/** 小 */
	Small: number;
	/** 單 */
	Odd: number;
	/** 雙 */
	Even: number;
	/** 4紅 */
	Red4: number;
	/** 3紅 */
	Red3: number;
	/** 1紅 */
	Red1: number;
	/** 0紅 */
	Red0: number;
}

/**
 * #paytable
 */
export class PaytableTable extends TableBase<PaytableTableRow> {}

export class PaytableTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 大 */
	Big: number;
	/** 小 */
	Small: number;
	/** 單 */
	Odd: number;
	/** 雙 */
	Even: number;
	/** 4紅 */
	Red4: number;
	/** 3紅 */
	Red3: number;
	/** 1紅 */
	Red1: number;
	/** 0紅 */
	Red0: number;
}

/**
 * #string
 */
export class StringTable extends TableBase<StringTableRow> {}

export class StringTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 英文訊息 */
	MsgEn: string;
	/** 繁體中文訊息 */
	MsgZnTw: string;
	/** 簡體中文訊息 */
	MsgZnCh: string;
	/** 越南文讯息 */
	MsgVi: string;
	/** 泰文讯息 */
	MsgTh: string;
}

/**
 * #sound
 */
export class SoundTable extends TableBase<SoundTableRow> {}

export class SoundTableRow implements ITableRow {
	/** 編號 */
	Id: number;
	/** 音效=1, 音樂 = 2 */
	Type: number;
	/** 繁體中文音檔位置 */
	PathZnTw: string;
	/** 英文音檔位置(預設音檔位置) */
	PathEn: string;
}
